; FILE FOR LAB7.ASM - SINE WAVE GENERATOR

          .def    start

          .bss    A,4,1           ;all symbols on one page
B         .set    A+1             ;assign all locations off 1st element
Y1        .set    A+2
Y2        .set    A+3

          .data
table:    .int    32768 * 1975/2000       ;A value
          .int    32768 * -1              ;B value
          .int    32768 *  0              ;Y1 value
          .int    32768 * 14/100          ;Y2 value
length:   .set    $-table                 ;length of the data table

buf_size  .set    50                      ;buffer size for graph
buf_addr  .usect  "buffer",buf_size,1     ;buffer address for graph

WDCR      .set    7029h                   ;address of watchdog control register

          .text     
start:
          LDP     #WDCR>>7         ;set data page
          SPLK    #11101000b, WDCR ;disable the watchdog

          LAR     AR1,#A          ;pointer to values in RAM (.bss)
          MAR     *,AR1           ;AR1 active auxiliary register
          RPT     #length-1       ;number of values to transfer
          BLPD    #table,*+       ;block move copy from table (.data) to (.bss)

          LDP     #A              ;load data page pointer for direct addressing
          SETC    SXM             ;specify 2's complement
          CLRC    OVM             ;allow intermediate overflows
          SPM     1               ;Q31 mode accumulator

          LAR     AR2,#buf_addr   ;pointer to buffer address for graph
          LAR     AR3,#buf_size   ;buffer control loop counter for graph
          MAR     *,AR2           ;AR2 active auxiliary register

sine:                             ;YOUR CODE STARTS HERE







                                  ;YOUR CODE ENDS HERE

          SACH      *+,AR3        ;buffer samples for graph
          BANZ      sine,AR2      ;branch test for number of graph samples
          LAR       AR2,#buf_addr ;reset buffer address pointer for graph
          LAR       AR3,#buf_size ;reset buffer control loop counter for graph

          B         sine          ;loop and re-calculate next sine value
