;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Lab 12: Capture Unit Interrupt Service Routine
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        .def cap_isr
        .def cap_rising, cap_falling, cap_duty

        .include f2407.h            ;address definitions

        .bss cap_rising,3,1         ;capture rising edge timestamp
cap_falling   .set   cap_rising+1   ;captured falling edge timestamp
cap_duty      .set   cap_rising+2   ;PWM duty cycle computed using captures

cap_isr:

;context save
        MAR     *,AR1               ;ARP=stack pointer
        MAR     *+                  ;skip one stack location
        SST     #1, *+              ;save ST1
        SST     #0, *+              ;save ST0
        SACH    *+                  ;save ACCH
        SACL    *+                  ;save ACCL
        
;clear the CAP1INT flag in EVAIFRC
        LDP     #DP_EVA             ;set data page
        LACC    #001b               ;ACC = 001b
        SACL    EVAIFRC             ;clear the CAP1INT flag

;read CAP1FIFO
        LACC    CAP1FIFO            ;read the top entry
        LDP     #cap_rising         ;set data page        
        SACL    cap_rising          ;store to memory
        LDP     #DP_EVA             ;set data page
        LACC    CAP1FIFO            ;read the 2nd entry
        LDP     #cap_rising         ;set data page        
        SACL    cap_falling         ;store to memory
        SETC    SXM                 ;do signed math
        SUB     cap_rising          ;compute the difference
        SACL    cap_duty            ;store to memory

;context restore
        MAR     *, AR1              ;ARP = AR1
        MAR     *-                  ;SP points to last entry
        LACL    *-                  ;restore ACCL
        ADD     *-,16               ;restore ACCH
        LST     #0, *-              ;restore ST0
        LST     #1, *-              ;restore ST1
        CLRC    INTM                ;re-enable global interrupts
        RET
